//+------------------------------------------------------------------+
//|                                                           DA.mq4 |
//|                     Copyright 2005-2017,  Yousufkhodja Sultonov. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2005-2017,  Yousufkhodja Sultonov."
#property link        "http://www.mql4.com"
#property description "Bulls / Bears Force Differential Average indicator by Yousufkhodja Sultonov."
#property description "Programmed by Sevan. sevan62@gmail.com"

#property indicator_buffers 1
#property indicator_level1  0.0
#property indicator_color1 Lime
#property indicator_separate_window

extern int DA_period = 1000;  // DA Period
extern int History   = 5000;  // History Bars

double BullsBearsBuf[];

int init()
  {
   string name="Double Differential Average ("+(string)DA_period+")";
   IndicatorShortName(name);
   SetIndexBuffer(0,BullsBearsBuf);
   
   SetIndexStyle(0,DRAW_LINE,0,2);
   
   SetIndexLabel(0,"Bulls&Bears Force");
   
   return(0);
  }

int start()
  {
   double blpd;   // Bulls Price difference
   double brpd;   // Bears Price difference
   int    bulls;  // Bulls counts
   int    bears;  // Bears counts
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=MathMin(Bars-counted_bars,Bars-1);
   if (limit>History-1) limit=History-1;
   for (int i=limit; i>=0; i--)
     {
      bulls=0; 
      bears=0; 
      blpd=0.0; 
      brpd=0.0;
      for (int j=DA_period; j>0; j--)
        {
         double pd=Close[i+j]-Close[i+j+1];
         if (pd>+0.5*_Point) 
           {
            bulls++;
            blpd+=pd;
           }
         if (pd<-0.5*_Point) 
           {
            bears++;
            brpd-=pd;
           }
        }
       if (bulls>0) blpd=(blpd/(double)bulls)/_Point;
       if (bears>0) brpd=(brpd/(double)bears)/_Point;
       BullsBearsBuf[i]=blpd-brpd;
      }
   return(0);
  }
//+------------------------------------------------------------------+
